import pickle
import matplotlib.pyplot as plt
import numpy as np
from os.path import join
from optparse import OptionParser

def adding_one(x):
    return x+1

def main():
	dict_repeats = {}
	with open("passed_sequenced_polished.pkl") as h: 
		non_redundant_reads = pickle.load(h)
	for u in non_redundant_reads: 
		if u not in dict_repeats:
			dict_repeats[u] = {}
		for read in non_redundant_reads[u]:
			copy = non_redundant_reads[u][read][0]
			if copy not in dict_repeats[u]:
				dict_repeats[u][copy] = 1
			else:
				dict_repeats[u][copy] += 1
	anarci_parsed = 0
	for error in non_redundant_reads:
	     for num in non_redundant_reads[error].values():
	         anarci_parsed += num[0]
	data  = []
	for u in dict_repeats:
		data.append(sum([[x]*dict_repeats[u][x] for x in dict_repeats[u]], []))
	with open("Error/ig_seq_residue_error_rate.txt", "r") as d:
		lines = d.readlines()
		residue_error_rate = lines[1].split(" ")[-2]
	fig, axis = plt.subplots()
	plt.boxplot(data)
	plt.axhline(y=anarci_parsed * float(residue_error_rate), xmin=0, xmax=1, hold=None)
	plt.xticks(map(adding_one, range(len(dict_repeats))),range(len(dict_repeats)))
	axis.set_ylabel("Number of repeats", fontsize=16)
	axis.set_xlabel("Number of flagged residue/positions", fontsize=16)
	plt.figtext(.5,0.9,"Number of flagged residue/positions versus sequence redundancy",fontsize=16,ha='center')
	fig.set_size_inches(7.5,4.5, forward=True)
	plt.savefig("Graphs/IncorrectVSredundancy", dpi= 300)
	plt.clf()
	return None

def calculate_passed_reads(Raw_reference_dataset):
	with open("passed_sequenced_polished.pkl") as h: 
		passed_reads_polished = pickle.load(h)[0]
	with open(Raw_reference_dataset, "rb") as r:
		dataset = pickle.load(r)
	print "The proportion of non-redundant sequences that were filtered by ABOSS: %f" % (float(len(passed_reads_polished))/len(dataset))
	print "The proportion of redundant sequences that were filtered by ABOSS: %f" % (float(sum([passed_reads_polished[x][0] for x in passed_reads_polished]))/sum(dataset.values()))
	return None

if __name__ == '__main__':
	parser = OptionParser()
	parser.add_option("-f", "--file",
                  action="store", type="string", dest="filename")
	(options, args) = parser.parse_args()
	print "--------------------------------------"
	if options.filename:
		filename = options.filename
		print "The file name is %s " % (filename)
	else:
		print "You did not indicate the filename"
	print "--------------------------------------"
	print filename
	main()
	try:
		calculate_passed_reads(filename)
	except:
		pass
